/* -------------------------------------------------------------------- */
/* SMS Client, send messages to mobile phones and pagers		*/
/*									*/
/* test_parser.c							*/
/*									*/
/*  Copyright (C) 1997,1998 Angelo Masci				*/
/*									*/
/*  This library is free software; you can redistribute it and/or	*/
/*  modify it under the terms of the GNU Library General Public		*/
/*  License as published by the Free Software Foundation; either	*/
/*  version 2 of the License, or (at your option) any later version.	*/
/*									*/
/*  This library is distributed in the hope that it will be useful,	*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*/
/*  Library General Public License for more details.			*/
/*									*/
/*  You should have received a copy of the GNU Library General Public	*/
/*  License along with this library; if not, write to the Free		*/
/*  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.	*/
/*									*/
/*  You can contact the author at this e-mail address:			*/
/*									*/
/*  angelo@styx.demon.co.uk						*/
/*									*/
/* -------------------------------------------------------------------- */
/* $Id$
   -------------------------------------------------------------------- */

#include <stdio.h>

#include "common.h"
#include "logfile.h"
#include "gs_token.h"
#include "gs_translate.h"

/* -------------------------------------------------------------------- */

#if !defined(MLOGFILE)
#error "MLOGFILE undefined"
#else
#define LOGFILE         MLOGFILE
#endif

#if !defined(MLOGLEVEL)
#error "MLOGLEVEL undefined" 
#else
#define LOGLEVEL	MLOGLEVEL
#endif

/* -------------------------------------------------------------------- */

static TOKEN_HEAP	
		*global_heap;

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
int main(int argc, char *argv[])
{
	char 	*str;


	/* ---------------------------- */

	set_logfile(LOGFILE);
	set_loglevel(LOGLEVEL);
	set_consolelog(TRUE);

	/* ---------------------------- */


	if (argc != 3)
	{
		lprintf(LOG_ERROR, "Usage: %s <variable> <file>\n", argv[0]);
		exit(1);
	}


	global_heap = gs_parse_file(argv[2]);
	if (global_heap == NULL)
	{
		lprintf(LOG_ERROR, "Error: Parsing file '%s'\n", argv[2]);
		exit(1);
	}

	dump_heap(global_heap, "global");

	str = get_strvalue(global_heap, argv[1]);
	if (str == NULL)
	{	printf("Var '%s' Not Found\n", argv[1]);
	}
	else
	{	printf("Var '%s' Found\n", argv[1]);
		printf("%s = %s\n", argv[1], str);
	}


	free_heap(global_heap);
	return 0;
}

